# RoCo backend

## Generate custom 2D patterns for papercraft, lasercutter, or wood

### Requirements

- Python 3
- `pip`
- `virtualenv` (optional)

### Install

(Optionally) create a virtualenv, and `pip install` the rocolib library:

- Stable release:
    
    - Edit your [pip configuration](https://pip.pypa.io/en/stable/user_guide/#config-file) to include or extend your `global` section:

        ```
        [global]
            extra-index-url = https://git.uclalemur.com/api/v4/projects/202/packages/pypi/simple
        ```

        then simply:

        ```
        $ pip install rocolib
        ```

    - Or entirely on the command line:

        ```
        $ pip install rocolib --extra-index-url https://git.uclalemur.com/api/v4/projects/202/packages/pypi/simple
        ```

- Latest development commit:

    ```
    $ pip install git+https://git.uclalemur.com/roco/rocolib#egg=rocolib
    ```

### Usage

If you created a virtualenv during install, enter it.  Then, you can import and use this module in scripts or the python REPL.

See [a simple tutorial](https://git.uclalemur.com/roco/tutorial) for more details on how to use RoCo.

### Development

```
% git clone https://git.uclalemur.com/roco/rocolib.git
% ./vstart.sh
```

`vstart.sh` creates the virtualenv and pip installs the requirements on first run; it launches a shell within that virtualenv whenever run.  Editing the source code will be reflected in the rocolib modules whenever re-imported.
